	ORG	100h
section .data


section .text
START:
	mov	ax,8480h
	int	1bh
	cmp	ah,0fh
	jne	END
	mov	[BIOS_Cylinder],cx
	mov	[BIOS_sector],dx

	mov	ax,0d800h
	mov	es,ax
	mov	bx,2700h
	call	check
	jnc	OK
	mov	bx,2300h
	call	check
	jnc	OK
	mov	bx,2100h
	call	check
	jnc	OK
	mov	ax,0e600h
	mov	es,ax
	call	check
	jc	END

OK:
	mov	ah,9
	mov	dx,hajime
	int	21h


	call	PCIcheck

	xor	ax,ax
	mov	ds,ax
	mov	al,[es:bx+0x12]
	cmp	al,01h
	jb	nidaime
	mov	al,8h
	mov	dx,45dh
	mov	[es:bx+4],dx
	mov	[es:bx+0x13],al
	or	[ds:45dh],al

	push	ds
	push	cs
	pop	ds
	mov	ah,9
	mov	dx,OK1
	int	21h	
	pop	ds
nidaime:
	mov	al,[es:bx+0x32]
	cmp	al,01h
	jb	sandaime
	mov	al,10h
	mov	dx,45dh
	mov	[es:bx+24h],dx
	mov	[es:bx+0x33],al
	or	[ds:45dh],al
	push	ds
	push	cs
	pop	ds
	mov	ah,9
	mov	dx,OK2
	int	21h	
	pop	ds
	
sandaime:
	mov	al,[es:bx+0x52]
	cmp	al,01h
	jb	yondaime
	mov	al,20h
	mov	dx,45eh
	mov	[es:bx+44h],dx
	mov	[es:bx+0x53],al
	or	[ds:45eh],al
	push	ds
	push	cs
	pop	ds
	mov	ah,9
	mov	dx,OK3
	int	21h	
	pop	ds

yondaime:
	mov	al,[es:bx+0x72]
	cmp	al,01h
	jb	END
	mov	al,40h
	mov	dx,45eh
	mov	[es:bx+64h],dx
	mov	[es:bx+0x73],al
	or	[ds:45eh],al
	push	ds
	push	cs
	pop	ds
	mov	ah,9
	mov	dx,OK4
	int	21h	
	pop	ds

	call	ram_to_rom
END:
	push	cs
	pop	ds
	mov	ah,9
	mov	dx,owari
	int	21h
	mov	ax,4c00h
	int	21h
	
check:
	mov	cx,[BIOS_Cylinder]
	cmp	[es:bx],cx
	jne	miss
	mov	dx,[BIOS_sector]
	cmp	[es:bx+7],dl
	jne	miss
	cmp	[es:bx+0ah],dh
	jne	miss
	clc
	ret
miss:
	stc
	ret

PCIcheck:
	mov	dx,0900h
	in	ax,dx
	cmp	ax,0ffffh
	jne	REDWOOD

    MOV    DX,0CF8h
    MOV    EAX,80000000h	;PCIRtBO[VJjYP intelyWildcatp
    OUT    DX,EAX
    MOV    DX,0CFCH
    IN     EAX,DX
	cmp     ax,8086h
    JE     Intel

  cmp     ax,1004h      	 ; VLSI_ChipSet@0005Ƃ0006̋UlRꉞȂ
  je      VLSI_ChipSet		;fXNgbvCanbep


	mov	dx,0cf8h
	mov	al,80h
	out	dx,al
	mov	dx,0c000h	;PCIRtBO[VJjY2 430LXp
	in	eax,dx
	cmp	ax,8086h
	jne	notwell_knownPAM

	mov	dx,0c05ch
	in	eax,dx
	or	ax,300h		;D800-DBFF̏Ԃ݉
	out	dx,eax
	ret

Intel:
    MOV    DX,0CF8h
    MOV    EAX,8000005Ch	;WX^5C-5F@@@5A4oCg͎܂I 
    OUT    DX,EAX
    MOV    DX,0CFCH		;D000-DFFF̏Ԃ
    IN     EAX,DX	
	or	eax,0300h		;D800-DBFF݉
	out	dx,ax
	ret

VLSI_ChipSet:
    MOV    DX,0CF8h
    MOV    EAX,80000064h	;WX^64-67
    OUT    DX,EAX
    MOV    DX,0CFEH		;6667hĂ@C000-DFFFh̃
    IN     AX,DX
     OR	AX,3000h		;܂D800݉
	out	dx,ax


REDWOOD:
	pop	ax
	jmp	END

notwell_knownPAM:
	mov	dx,1e8eh
	mov	al,81h		;LBApb`Ăꍇ͂łRAMɂȂĂ͂ǂ
	out	dx,al
	ret

ram_to_rom:
    MOV    DX,0CF8h
    MOV    EAX,80000000h	;PCIRtBO[VJjYP intelyWildcatp
    OUT    DX,EAX
    MOV    DX,0CFCH
    IN     EAX,DX
	cmp     ax,8086h
    JE     Intel_End

  cmp     ax,1004h      	 ; VLSI_ChipSet@0005Ƃ0006̋UlRꉞȂ
  je      VLSI_End		;fXNgbvCanbep


	mov	dx,0cf8h
	mov	al,80h
	out	dx,al
	mov	dx,0c000h	;PCIRtBO[VJjY2 430LXp
	in	eax,dx
	cmp	ax,8086h
	je	LX430End
	ret

LX430End:
	mov	dx,0cf8h
	mov	al,80h
	out	dx,al
	mov	dx,0c059h
	in	al,dx
	and	al,~20h	;ݕs
	or	al,40h		;LbV
	out	dx,al		;WX^1byteÂANZX\ 32bitƂȂĂ
	mov	dx,0c05ch
	in	eax,dx
	and	ax,~200h
	out	dx,eax		;fobKł͂ƗĂ̂ IPLwareiKł͏݉tOȂ
				;Ȃ??? IDE-BIOSĂԓxD800:2072D800:2076ɕۊǂĂg邽߂ۂ
	mov	dx,0cf8h
	xor	al,al
	out	dx,al
	ret

Intel_End:
    MOV    DX,0CF8h
    MOV    EAX,8000005Ch	;WX^5C-5F@@@5A4oCg͎܂I 
    OUT    DX,EAX
    MOV    DX,0CFCH		;D000-DFFF̏Ԃ
    IN     EAX,DX	
	and	eax,~200h	;D800-DB00݋֎~@LbVG炸
	out	dx,ax
	ret

VLSI_End:
    MOV    DX,0CF8h
    MOV    EAX,80000064h	;WX^64-67
    OUT    DX,EAX
    MOV    DX,0CFEH		;6667hĂ@C000-DFFFh̃
    IN     AX,DX
	and	ax,~1000h
	out	dx,ax
	ret




BIOS_Cylinder	dw	0h	;offset0
BIOS_sector	db	0h	;offset+07
BIOS_head	db	0h	;offset+0a
hajime db	'o܂B',0dh,0ah,'$'
owari	db	'I܂B',0dh,0ah,'$'
OK1	db	'1ڂ̃}`ZN^ݒs܂B',0dh,0ah,'$'
OK2	db	'2ڂ̃}`ZN^ݒs܂B',0dh,0ah,'$'
OK3	db	'3ڂ̃}`ZN^ݒs܂B',0dh,0ah,'$'
OK4	db	'4ڂ̃}`ZN^ݒs܂B',0dh,0ah,'$'

times	200h	db	0		;[JX^bN߂ɂƂ@Int1Bhp
stack: